  {----------------------------------------------------------------------}
                                 Unit  Drives;
  {----------------------------------------------------------------------}


  {----------------------------------------------------------------------}
                                   Interface
  {----------------------------------------------------------------------}

Uses
  DOS;

Function DOSDrives : String;
{ 㭪 頥 ப ᨬ -
 㯭  DOS ᪨ ᪮ }

Function DiskNum (Drive : Char) : Byte;
{ 㭪 頥  . ᪠:
'A'-1,'B'-2,'C'-3   }

Function CurDir (Drive : Char) : String;
{ 㭪 頥  ⥪饣 ⠫
 㪠 ᪥. ᫨ ࠬ - " ", 
祭 㭪樨 㤥 ࠢ ⥪饬 ⠫
 ⥪饬 ᪥ }

Function MSCDEX : Boolean;
{ 㭪 頥 TRUE, ᫨
⠭ ७ CD_ROM }

Function CDDrives : String;
{ 㭪 頥 ப ᨬ -
 㯭 CD ᪮ }

Function DOSDrivesEC : String;
{ 㭪 頥 ப ᨬ -  㯭
 DOS ᪨ ᪮ (᪫ ன⢠ CD-ROM) }


  {----------------------------------------------------------------------}
                                Implementation
  {----------------------------------------------------------------------}

Function DOSDrives : String;
Var
  R      : Registers;
  Drives : String;
  I      : Byte;
  Ch     : Char;
Begin
  Ch := Pred ('A');
  Drives := '';
  For I := 1 to 26 do
    Begin
      Ch := Succ (Ch);
      R.AH := $44;
      R.AL := 8;
      R.BL := I;
      MsDOS (R);
      If R.AX <= 1 then Drives := Drives + Ch
    End;
  DOSDrives := Drives
End;

Function DiskNum (Drive : Char) : Byte;
Begin
  Drive := UpCase (Drive);
  DiskNum := Ord (Drive) - Ord ('A') + 1
End;

Function CurDir (Drive : Char) : String;
Var
  D : Byte;
  S : String;
Begin
  Drive := UpCase (Drive);
  If Drive = ' ' then D := 0
  Else D := DiskNum (Drive);
  GetDir(D, S);
  CurDir := S
End;

Function MSCDEX : Boolean;
Var R : Registers;
Begin
  R.AX := $1500;
  R.BX := 0;
  Intr ($2F, R);
  MSCDEX := R.BX > 0
End;

Function CDDrives : String;
Type
  PCD = Array [1..26] of Byte;
Var
  R     : Registers;
  S     : String;
  Count,
  I     : Byte;
  P     : ^PCD;
Label L;
Begin
  S := '';
  R.AX := $1500;
  R.BX := 0;
  Intr ($2F, R);
  If R.BX = 0 then Goto L;
  Count := R.BX;
  R.AX := $150D;
  Intr ($2F, R);
  P := Ptr (R.ES, R.BX);
  For I := 1 to Count do
    S := S+Chr(P^[I]+65);
l:
  CDDrives := S
End;

Function DOSDrivesEC : String;
Var
  S, SC : String;
  I     : Byte;
Label L;
Begin
  S := DOSDrives;
  SC := CDDrives;
  If SC = '' then Goto L;
  For I := 1 to Length(SC) do
    If Pos(SC[I],S) > 0 then Delete (S,Pos(SC[I],S),1);
L:
  DOSDrivesEC := S
End;

End.
